// SVN_ZipExt.cpp : Implementation of CSVN_ZipExt

#include "stdafx.h"
#include "SVN_ZipExt.h"


namespace {

	#define DisplayString "SVN Zip"

	//space between the edge of the context menu and the start of the icon
	const int padding=0;
	
	//space between the icon and the text	
	const int spacing=2;
	const int icon_id=IDI_ZIP_ICON;
	
	//if there are 0, the icon will use it's natural dimensions;
	const int icon_w=0;
	const int icon_h=0;

	void do_com(const char * folder) {
		char com[2*MAX_PATH];
		sprintf(com, "svn_zip \"%s\"", folder);
		system(com);
	}
}


HINSTANCE get_hinst();

HRESULT CSVN_ZipExt::QueryContextMenu(
	HMENU	hmenu, 
	UINT	indexMenu, 
	UINT	idCmdFirst, 
	UINT	/*idCmdLast*/, 
	UINT	uFlags )
{



	if ( uFlags & CMF_DEFAULTONLY )
        {
        return MAKE_HRESULT ( SEVERITY_SUCCESS, FACILITY_NULL, 0 );
        }

    // Get the version of the shell.  If it's > 4, we can use an owner-drawn 
    // item.

	bool bUseOwnerDraw = false;
	HINSTANCE hinstShell;

    hinstShell = GetModuleHandle ( _T("shell32") );

    if ( NULL != hinstShell )
        {
        DLLGETVERSIONPROC pProc;

        pProc = (DLLGETVERSIONPROC) GetProcAddress ( hinstShell, "DllGetVersion" );

        if ( NULL != pProc )
            {
            DLLVERSIONINFO rInfo = { sizeof(DLLVERSIONINFO) };

            if ( SUCCEEDED( pProc ( &rInfo ) ))
                {
                // Check for a major version greater than 4 (like on Win 2K),
                // or minor version >= 71 (95/NT4 with Active Desktop).

                if ( rInfo.dwMajorVersion > 4  ||
                     rInfo.dwMinorVersion >= 71  )
                    {
                    bUseOwnerDraw = true;
                    }
                }
            }
        }

	MENUITEMINFO mii;

    mii.cbSize = sizeof(MENUITEMINFO);
    mii.fMask  = MIIM_ID | MIIM_TYPE;
    mii.fType  = bUseOwnerDraw ? MFT_OWNERDRAW : MFT_BITMAP;
    mii.wID    = idCmdFirst;

	if ( !bUseOwnerDraw )
        {
        
        // So, i'm aware that i ought to do *something* here if we have an old version of the
        // shell, and this seems like it *might* work, but i've never tested it, and
        // i don't know nearly enough about the mysteries of the windows framework to
        // have any real sense whether or not this is likely to do what i want it to.
        //mii.dwTypeData = (LPTSTR) IconToBitmap(icon_id, (COLORREF)GetSysColor(COLOR_MENU));
    
		//we could just throw and error, but that might actually be worse than doing something
		//slighly incorrect.
		//throw std::logic_error("this extension is not compatiable with the given shell version.");
    }

    InsertMenuItem ( hmenu, indexMenu, TRUE, &mii );

    // Store the menu item's ID so we can check against it later when
    // WM_MEASUREITEM/WM_DRAWITEM are sent.
        
    m_uOurItemID = idCmdFirst;

    // Tell the shell we added 1 top-level menu item.

    return MAKE_HRESULT ( SEVERITY_SUCCESS, FACILITY_NULL, 1 );

}



// CSimpleExt::InvokeCommand
HRESULT CSVN_ZipExt::InvokeCommand(LPCMINVOKECOMMANDINFO lpcmi)
{
	try {
		do_com(m_szFile);
	} catch ( ... ) {
		return E_FAIL;
	}

	return S_OK;
}



HRESULT CSVN_ZipExt::GetCommandString(UINT /*idCmd*/, UINT uFlags, UINT* /*pwReserved*/, LPSTR pszText, UINT cchMax)
{
	try {

		USES_CONVERSION;

		// We don't care about the command ID, since we have a single item

		// This is rather funky, but GCS_HELPTEXTA refers to a single bit (4) and 
		// GCS_UNICODE refers to single bit (1), but GCS_HELPTEXTW is a combination
		// of those values (5).  This works on both NT and 95.
		if ( uFlags & GCS_HELPTEXTA ) {

			// I'm assuming that this value always contains the number of bytes
			// available for the message, just to be safe.  So half it for Unicode
			// characters.
			const int cChars = cchMax / sizeof(TCHAR);

			// Create some storage on the stack for building the help text
			LPTSTR szHelpText = reinterpret_cast<LPTSTR>( _alloca( cChars ) );
			memset( szHelpText, 0, cChars );

			// Create a generic version of the help text depending on the number
			// of file selected
	
				_sntprintf( szHelpText, cChars - 1, _T("Copy full path of file to clipboard (%s)"), m_szFile );
			

			// Do character conversion depending on flag
			if ( uFlags & GCS_UNICODE ) {
				wcsncpy( reinterpret_cast<LPWSTR>(pszText), T2W(szHelpText), cChars );
			} else {
				strncpy(pszText, T2A(szHelpText), cchMax);
			}
		}
	} catch ( ... ) {
		return E_FAIL;
	}

	return S_OK;
}



// IShellExtInit::Initialize
HRESULT CSVN_ZipExt::Initialize(LPCITEMIDLIST /*pidlFolder*/, LPDATAOBJECT lpdobj, HKEY /*hKeyProgID*/)
{
	try {

		if ( lpdobj == NULL )
			return E_INVALIDARG;

		// Get the data as CF_HDROP
		STGMEDIUM medium;
		FORMATETC fe = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
		HRESULT hr = lpdobj->GetData( &fe, &medium );
		if ( FAILED( hr ) )
			return E_INVALIDARG;


		memset( m_szFile, 0, sizeof m_szFile );
		DragQueryFile( reinterpret_cast<HDROP>(medium.hGlobal), 
						0, 
						m_szFile, 
						sizeof(m_szFile)/sizeof(m_szFile[0]) );



		ReleaseStgMedium(&medium);
		return hr;

	} catch ( ... ) {
		return E_FAIL;
	}
};




// CComObjectRootEx overrides
void CSVN_ZipExt::FinalRelease()
{
	// Destroy the bitmap that we created in IContextMenu::QueryContextMenu
	try {
		::DeleteObject( m_hbmpUnchecked );
	} catch ( ... ) {
	}
}

STDMETHODIMP CSVN_ZipExt::MenuMessageHandler ( UINT uMsg, WPARAM wParam,
                                                  LPARAM lParam, LRESULT* pResult )
{
    switch ( uMsg )
        {
        case WM_MEASUREITEM:
            {
            return OnMeasureItem ( (MEASUREITEMSTRUCT*) lParam, pResult );
            }
        break;

        case WM_DRAWITEM:
            {
            return OnDrawItem ( (DRAWITEMSTRUCT*) lParam, pResult );
            }
        break;
        }

    return S_OK;
}

STDMETHODIMP CSVN_ZipExt::HandleMenuMsg ( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());

    // res is a dummy LRESULT variable.  It's not used (IContextMenu2::HandleMenuMsg()
    // doesn't provide a way to return values), but it's here so that the code 
    // in MenuMessageHandler() can be the same regardless of which interface it
    // gets called through (IContextMenu2 or 3).

LRESULT res;

    return MenuMessageHandler ( uMsg, wParam, lParam, &res );
}

STDMETHODIMP CSVN_ZipExt::HandleMenuMsg2 ( UINT uMsg, WPARAM wParam, LPARAM lParam,
                                              LRESULT* pResult )
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());

    // For messages that have no return value, pResult is NULL.  This is
    // _very_ mean on the part of MS since it forces us to check whether
    // pResult is valid before using it.  You'd think that a pointer to
    // a "return value" would always be valid, but alas no.
    // If it is NULL, I create a dummy LRESULT variable, so the code in
    // MenuMessageHandler() will always have a valid pResult pointer.

    if ( NULL == pResult )
        {
        LRESULT res;
        return MenuMessageHandler ( uMsg, wParam, lParam, &res );
        }
    else
        {
        return MenuMessageHandler ( uMsg, wParam, lParam, pResult );
        }
}



STDMETHODIMP CSVN_ZipExt::OnMeasureItem ( MEASUREITEMSTRUCT* pmis, LRESULT* pResult )
{

	if (pmis==NULL) return S_OK;
	
	*pResult = TRUE;
	pmis->itemWidth = 0;
	pmis->itemHeight = 0;
	POINT size;
	
	//get the information about the shell dc, font, ...
	NONCLIENTMETRICS ncm;
	ncm.cbSize = sizeof(NONCLIENTMETRICS);
	if (SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncm, 0)==0)
		return S_OK;
	HDC hDC = CreateCompatibleDC(NULL);
	if (hDC == NULL)
		return S_OK;
	HFONT hFont = CreateFontIndirect(&ncm.lfMenuFont);
	if (hFont == NULL)
		return S_OK;
	HFONT oldFont = (HFONT)SelectObject(hDC, hFont);
	
	GetTextExtentPoint32(hDC, DisplayString, _tcslen(DisplayString), (SIZE*)&size);
	
	LPtoDP(hDC, &size, 1);
	
	//now release the font and dc
	SelectObject(hDC, oldFont);
	DeleteObject(hFont);
	DeleteDC(hDC);

	//width of string + height of string (~ width of icon) + space between
	pmis->itemWidth = size.x + size.y + spacing;						
	pmis->itemHeight = max(size.y + 4, ncm.iMenuHeight);		//two pixels on both sides

    return S_OK;
}

STDMETHODIMP CSVN_ZipExt::OnDrawItem ( DRAWITEMSTRUCT* pdis, LRESULT* pResult )
{
	
	LPCTSTR resource;
	TCHAR * szItem = DisplayString;
	DRAWITEMSTRUCT* lpdis = pdis;
	if ((lpdis==NULL)||(lpdis->CtlType != ODT_MENU))
		return S_OK;		//not for a menu
	resource = DisplayString;
	if (resource == NULL)
		return S_OK;
	//mbtowc(szItem,DisplayString,MAX_PATH);
	if (lpdis->itemAction & (ODA_DRAWENTIRE|ODA_SELECT))
	{
		int ix, iy;
		RECT rt, rtTemp;
		SIZE size;
		//choose text colors
		if (lpdis->itemState & ODS_SELECTED)
		{
			COLORREF crText;
			if (lpdis->itemState & ODS_GRAYED)
				crText = SetTextColor(lpdis->hDC, GetSysColor(COLOR_GRAYTEXT)); //RGB(128, 128, 128));
			else
				crText = SetTextColor(lpdis->hDC, GetSysColor(COLOR_HIGHLIGHTTEXT));
			SetBkColor(lpdis->hDC, GetSysColor(COLOR_HIGHLIGHT));
		}
		CopyRect(&rtTemp, &(lpdis->rcItem));

		ix = lpdis->rcItem.left + padding;
		SetRect(&rt, ix, rtTemp.top, ix + 16, rtTemp.bottom);

		HICON hIcon = (HICON)LoadImage(get_hinst(), MAKEINTRESOURCE(icon_id), IMAGE_ICON, icon_w, icon_w, LR_DEFAULTCOLOR);;


		if (hIcon == NULL)
			return S_OK;
		//convert the icon into a bitmap
		ICONINFO ii;
		if (GetIconInfo(hIcon, &ii)==FALSE)
			return S_OK;
		HBITMAP hbmItem = ii.hbmColor; 
		if (hbmItem)
		{
			BITMAP bm;
			GetObject(hbmItem, sizeof(bm), &bm);

			int tempY = lpdis->rcItem.top + ((lpdis->rcItem.bottom - lpdis->rcItem.top) - bm.bmHeight) / 2;
			SetRect(&rt, ix, tempY, ix + 16, tempY + 16);

			ExtTextOut(lpdis->hDC, 0, 0, ETO_CLIPPED|ETO_OPAQUE, &rtTemp, NULL, 0, (LPINT)NULL);
			rtTemp.left = rt.right;

			HDC hDCTemp = CreateCompatibleDC(lpdis->hDC);
			SelectObject(hDCTemp, hbmItem);
			DrawIconEx(lpdis->hDC, rt.left , rt.top, hIcon, bm.bmWidth, bm.bmHeight,
				0, NULL, DI_NORMAL);

			DeleteDC(hDCTemp);
			DeleteObject(hbmItem);
		} // if (hbmItem)
		

		ix = rt.right + spacing;

		//free memory
		DeleteObject(ii.hbmColor);
		DeleteObject(ii.hbmMask);
		DestroyIcon(hIcon);


		//draw menu text
		GetTextExtentPoint32(lpdis->hDC, szItem, lstrlen(szItem), &size);
		iy = ((lpdis->rcItem.bottom - lpdis->rcItem.top) - size.cy) / 2;
		iy = lpdis->rcItem.top + (iy>=0 ? iy : 0);
		SetRect(&rt, ix , iy, lpdis->rcItem.right - 4, lpdis->rcItem.bottom);
		ExtTextOut(lpdis->hDC, ix, iy, ETO_CLIPPED|ETO_OPAQUE, &rtTemp, NULL, 0, (LPINT)NULL);
		if (lpdis->itemState & ODS_GRAYED)
		{        
			SetBkMode(lpdis->hDC, TRANSPARENT);
			OffsetRect( &rt, 1, 1 );
			SetTextColor( lpdis->hDC, RGB(255,255,255) );
			DrawText( lpdis->hDC, szItem, lstrlen(szItem), &rt, DT_LEFT|DT_EXPANDTABS );
			OffsetRect( &rt, -1, -1 );
			SetTextColor( lpdis->hDC, RGB(128,128,128) );
			DrawText( lpdis->hDC, szItem, lstrlen(szItem), &rt, DT_LEFT|DT_EXPANDTABS );         
		}
		else
			DrawText( lpdis->hDC, szItem, lstrlen(szItem), &rt, DT_LEFT|DT_EXPANDTABS );
	}
	*pResult = TRUE;
	
	return S_OK;
}

